import java.math.*;
import java.sql.*;
import java.util.*;
import java.util.Date;

import javax.management.RuntimeErrorException;

import org.dom4j.*;

import com.Batch;
import com.ResourceControlCenter;
import com.Sql;
import com.tool;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.justep.system.context.ContextHelper;
import com.justep.system.data.KSQL;
import com.justep.system.data.Row;
import com.justep.system.data.SQL;
import com.justep.system.data.Table;

public class TaskBook {

	/** 此java文件公用全局变量 **/
	/******************************************************************************************************************/
	/***/
	private static final String DATA_MODEL = "/DB/table/data";// 表的模块 /***/
	/***/
	private static final String DATA_MODELOFK3 = "/DB/kingdeeK3/data";// k3数据表的模块
																		// /***/
	/***/
	private static String ERRORMESSAGE = "";// 错误信息 /***/
	/***/
	private static String ERRORSTATUS = "ok";// 错误标识
												// 默认“ok”，如果运算过程中出现错误，则将此改为error
												// /***/
	/***/
	private static String personName = ContextHelper.getPersonMember().getName();// 当前登陆人名称
																					// /***/
	/***/
	private static String personID = ContextHelper.getPersonMember().getID();// 当前登陆人ID
																				// /***/

	/******************************************************************************************************************/

	/**
	 * 
	 * @Title: MRPOperation
	 * @Description: 对主生产计划的添加存货进行效验
	 * @param fMainID
	 *            生产任务书主表ID
	 * @author 黄英集
	 * @date 2018-9-27
	 * @return JSONObject 返回类型
	 * 
	 */
	public static JSONObject IFcommonMode(String fMainID) {
		String sql = "select * from MES_BookOfManageList a where a.fMainID='" + fMainID + "'";
		Table table = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
		JSONObject object = new JSONObject();
		JSONObject objectAll = new JSONObject();
		String stop = "";
		int sign = 0;

		try {

			// 判断相同编码的交货期和共模标识是否一样
			if (table.size() > 0) {
				Iterator<Row> rows = table.iterator();
				while (rows.hasNext()) {
					Row row = rows.next();

					String StockCode = row.getString("fStockCode"); // 存货编码
					String CommonModeSign = row.getString("fCommonModeSign"); // 共模标识
					// 查询指定共模标识的任务书明细记录
					String strOne = "(select a.fStockCode,a.fNumber,a.fDeliveryDate,a.fCommonModeSign from MES_BookOfManageList a where a.fMainID='" + fMainID + "' and a.fStockCode='" + StockCode
							+ "') b";
					// 判断相同编码的交货期和共模标识是否一样
					sql = "select b.fCommonModeSign from " + strOne + " group by b.fCommonModeSign having count(*)>1";
					Table tableA = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
					sql = "select b.fDeliveryDate from " + strOne + " group by b.fDeliveryDate having count(*)>1";
					Table tableB = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
					if (tableA.size() > 0 || tableB.size() > 0) {
						objectAll.put(sign + "", StockCode);
						sign = sign + 1;
						stop = "stop";
					}

				}

				if ("stop".equals(stop)) {
					object.put("signOne", objectAll);
					stop = "";
					int i = 1 / 0;
					return object;
				}
			}

			// 判断共模标识一样的存货编码是否共模产品
			if (table.size() > 0) {
				Iterator<Row> rows = table.iterator();
				while (rows.hasNext()) {
					Row row = rows.next();
					String StockCode = row.getString("fStockCode"); // 存货编码
					String CommonModeSign = row.getString("fCommonModeSign"); // 共模标识
					// 查询指定共模标识的任务书明细记录
					String strOne = "(select a.fStockCode,a.fNumber,a.fDeliveryDate,a.fCommonModeSign from MES_BookOfManageList a where a.fMainID='" + fMainID + "' and a.fCommonModeSign='"
							+ CommonModeSign + "') b";

					String IFContain = "select c.fMainID from CAPP_MouldProductList c where c.fStockCode='" + StockCode + "'";
					Table tableContain = SQL.select(Sql.DBMySql(IFContain), null, DATA_MODEL);
					// 判断是否有fMainID值（是否在模具使用性中）
					if (tableContain.size() != 0) {
						// 判断指定存货编码的模具是有效状态
						sql = "select * from CAPP_Mould where fid in (select c.fMainID from CAPP_MouldProductList c where c.fStockCode='" + StockCode + "') and fStatus='有效'";
						Table table1 = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
						// 查询指定存货编码的共模产品
						String strTwo = "(select d.fStockCode as fstock,d.fRationNum from CAPP_MouldProductList d where d.fMainID in (select c.fMainID from CAPP_MouldProductList c where c.fStockCode='"
								+ StockCode + "')) e";
						if (table1.size() == 0) {

							strTwo = "(select d.fStockCode as fstock,d.fRationNum from CAPP_MouldProductList d where d.fStockCode='" + StockCode + "') e";
						}

						// 任务书明细记录左连接共模
						sql = "select * from " + strOne + " left join " + strTwo + " on e.fstock=b.fStockCode where e.fstock is null";
						Table tableOne = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
						if (tableOne.size() > 0) {
							objectAll.put(sign + "", CommonModeSign);
							sign = sign + 1;
							stop = "stop";
						}
					} else {
						String strThr = "select a.fStockCode,a.fNumber,a.fDeliveryDate,a.fCommonModeSign from MES_BookOfManageList a where a.fMainID='" + fMainID + "' and a.fCommonModeSign='"
								+ CommonModeSign + "'";
						Table tableThr = SQL.select(Sql.DBMySql(strThr), null, DATA_MODEL);
						if (tableThr.size() > 1) {
							objectAll.put(sign + "", CommonModeSign);
							sign = sign + 1;
							stop = "stop";
						}
					}

				}

				if ("stop".equals(stop)) {
					object.put("signTwo", objectAll);
					stop = "";
					int i = 1 / 0;
					return object;
				}

			}

			// //(在需要判断数量比例是否符合可以用)
			// if(table.size()>0){
			// Iterator<Row> rows = table.iterator();
			// while(rows.hasNext()){
			// Row row = rows.next();
			// String StockCode = row.getString("fStockCode"); //存货编码
			// String CommonModeSign = row.getString("fCommonModeSign"); //共模标识
			// //查询指定共模标识的任务书明细记录
			// String
			// strOne="(select a.fStockCode,a.fNumber,a.fDeliveryDate,a.fCommonModeSign from MES_BookOfManageList a where a.fMainID='"+fMainID+"' and a.fCommonModeSign='"+CommonModeSign+"') b";
			// //判断指定存货编码的模具是有效状态
			// sql="select * from CAPP_Mould where fid in (select c.fMainID from CAPP_MouldProductList c where c.fStockCode='"+StockCode+"') and fStatus='有效'";
			// Table table1 = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
			// //查询指定存货编码的共模产品
			// String
			// strTwo="(select d.fStockCode as fstock,d.fRationNum from CAPP_MouldProductList d where d.fMainID in (select c.fMainID from CAPP_MouldProductList c where c.fStockCode='"+StockCode+"')) e";
			// if(table1.size()==0){
			// strTwo="(select d.fStockCode as fstock,d.fRationNum from CAPP_MouldProductList d where d.fStockCode='"+StockCode+"') e";
			// }
			// //共模左连接任务书明细记录
			// sql="select * from "+strTwo+" left join "+strOne+" on b.fStockCode=e.fstock where b.fStockCode is not null";
			// Table tableOne = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
			//
			// if(tableOne.size()>1){
			// //判断是否存在比例符合的记录
			// sql="select fNumber/fRationNum as Multiple from "+strTwo+" left join "+strOne+" on b.fStockCode=e.fstock where b.fStockCode is not null group by Multiple having count(*)>1";
			// Table tableTwo = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
			// if(tableTwo.size()==0){
			// objectAll.put(sign+"", CommonModeSign);
			// sign=sign+1;
			// stop="stop";
			// }
			// }
			// }
			//
			// if(stop.equals("stop")){
			// object.put("signThou", objectAll);
			// stop="";
			// int i=1/0;
			// return object;
			// }
			// }

			// 判断是否添加共模的方法
			if (table.size() > 0) {
				Iterator<Row> rows = table.iterator();
				while (rows.hasNext()) {
					Row row = rows.next();
					String StockCode = row.getString("fStockCode"); // 存货编码
					String CommonModeSign = row.getString("fCommonModeSign"); // 共模标识
					// 查询指定共模标识的任务书明细记录
					String strOne = "(select a.fStockCode,a.fNumber,a.fDeliveryDate,a.fCommonModeSign from MES_BookOfManageList a where a.fMainID='" + fMainID + "' and a.fCommonModeSign='"
							+ CommonModeSign + "') b";
					// 判断指定存货编码的模具是有效状态
					sql = "select * from CAPP_Mould where fid in (select c.fMainID from CAPP_MouldProductList c where c.fStockCode='" + StockCode + "') and fStatus='有效'";
					Table table1 = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
					// 查询指定存货编码的共模产品
					String strTwo = "(select d.fStockCode as fstock,d.fRationNum from CAPP_MouldProductList d where d.fMainID in (select c.fID from capp_mould c where c.fStockCode='" + CommonModeSign
							+ "')) e";
					if (table1.size() == 0) {// 为无效状态时
						strTwo = "(select d.fStockCode as fstock,d.fRationNum from CAPP_MouldProductList d where d.fStockCode='" + StockCode + "') e";
					}
					// 共模左连接任务书明细记录
					sql = "select * from " + strTwo + " left join " + strOne + " on b.fStockCode=e.fstock";
					Table tableOne = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);

					// 判断是否存在存货编码为null的数据
					sql = "select * from " + strTwo + " left join " + strOne + " on b.fStockCode=e.fstock where b.fStockCode is null";
					Table tableTwo = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);

					// 存放到json中
					if (tableTwo.size() > 0) {
						objectAll.put(sign + "", tableOne);
						sign = sign + 1;
						stop = "stop";
					}
				}

				if ("stop".equals(stop)) {
					object.put("signAdd", objectAll);
					stop = "";
				} else {
					object.put("signSuccess", "");
				}

			}

		} catch (Exception e) {
			throw new RuntimeException(object.toJSONString());

		}

		return object;

	}

	/**
	 * 
	 * @Title: generatingOrder
	 * @Description: TODO(将MPS运算结果生成主生产计划)
	 * @param IDs
	 *            参数
	 * @author ChenXiaoChen
	 * @date 2019-4-17
	 * @return void 返回类型
	 * 
	 */
	public static String generatingOrder(String IDs) {
		try {
			//System.out.println(personID);
			String thisID = UUID.randomUUID().randomUUID().toString().replace("-", "");
			String ksql = "insert into MES_BookOfManage a (a,a.version,a.fDocumentNumber,a.fTaskType,a.fStatus,a.fCreatePersonID," +
					"a.fCreateDateTime,a.fLastUpdatePersonID,a.fLastUpdateDateTime) " +
					"values('"+thisID+"',0,:nextSeqString(format('%s%s','RW',format('%1$ty%1$tm%1$td', :currentDateTime())),'0000'),'订单','拟制'," +
					" :currentPersonID(),:currentDateTime(),:currentPersonID(),:currentDateTime())";
			KSQL.executeUpdate(ksql, null, DATA_MODEL, null);
			String sql = "select a.* from MES_MPSResultList a where "+IDs+" ";
			Table table = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
			Iterator<Row> rows = table.iterator();
			while(rows.hasNext()){
				Row row = rows.next();
				sql = "insert into MES_BookOfManageList (fid,version,fMainID,fStockCode,fNumber,fCommonModeSign,fDeliveryDate,fCreatePersonID," +
						"fCreateDateTime,fLastUpdatePersonID,fLastUpdateDateTime,fSign)  " +
						"values(REPLACE(UUID(),'-',''),0,'"+thisID+"','"+row.getString("fStockCode")+"',"+row.getInt("fNumber")+"," +
						"(select b.fStockCode from CAPP_MouldProductList a left join CAPP_Mould b on a.fMainID = b.fID where a.fStockCode = '"+row.getString("fStockCode")+"' and b.fStatus = '有效' )," +
						"'"+row.getDate("fDeliveryDate")+"','"+personID+"',now(),'"+personID+"',now(),1) ";
				SQL.executeUpdate(Sql.DBMySql(sql), null, DATA_MODEL);
			}
			sql = "update MES_MPSResultList a set a.fStatus = '已投产' where "+IDs+" ";
			SQL.executeUpdate(Sql.DBMySql(sql), null, DATA_MODEL);
			System.out.println(personID);
			// String thisID =
			// UUID.randomUUID().randomUUID().toString().replace("-", "");
			// String ksql =
			// "insert into MES_BookOfManage a (a,a.version,a.fDocumentNumber,a.fTaskType,a.fStatus,a.fCreatePersonID,"
			// +
			// "a.fCreateDateTime,a.fLastUpdatePersonID,a.fLastUpdateDateTime) "
			// +
			// "values('"+thisID+"',0,:nextSeqString(format('%s%s','RW',format('%1$ty%1$tm%1$td', :currentDateTime())),'0000'),'订单','拟制',"
			// +
			// " :currentPersonID(),:currentDateTime(),:currentPersonID(),:currentDateTime())";
			// KSQL.executeUpdate(ksql, null, DATA_MODEL, null);
			// String sql =
			// "select a.* from MES_MPSResultList a where "+IDs+" ";
			// Table table = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);
			// Iterator<Row> rows = table.iterator();
			// while(rows.hasNext()){
			// Row row = rows.next();
			// sql =
			// "insert into MES_BookOfManageList (fid,version,fMainID,fStockCode,fNumber,fCommonModeSign,fDeliveryDate,fCreatePersonID,"
			// +
			// "fCreateDateTime,fLastUpdatePersonID,fLastUpdateDateTime)  " +
			// "values(REPLACE(UUID(),'-',''),0,'"+thisID+"','"+row.getString("fStockCode")+"',"+row.getInt("fNumber")+","
			// +
			// "(select b.fStockCode from CAPP_MouldProductList a left join CAPP_Mould b on a.fMainID = b.fID where a.fStockCode = '"+row.getString("fStockCode")+"' and b.fStatus = '有效' ),"
			// +
			// "'"+row.getDate("fDeliveryDate")+"','"+personID+"',now(),'"+personID+"',now()) ";
			// SQL.executeUpdate(Sql.DBMySql(sql), null, DATA_MODEL);
			// }
			// sql =
			// "update MES_MPSResultList a set a.fStatus = '已投产' where "+IDs+" ";
			// SQL.executeUpdate(Sql.DBMySql(sql), null, DATA_MODEL);

			return "ok";
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(e.getMessage());
		}
	}

	/**
	 * 
	 * @Title: generateOrderByCustomer
	 * @Description: TODO 根据客户订单生成销售订单
	 * @param IDs
	 *            参数
	 * @author ChenXiaoChen
	 * @return
	 * @date 2019-6-26
	 * @return void 返回类型
	 * 
	 */

	public static String generateOrderByCustomer(String customerID, String list) {
		try {

			String thisID = UUID.randomUUID().randomUUID().toString().replace("-", "");// 主表ID
			String batchno = Batch.nextSeqFormat("RW");// 流水号
			String ksql = "insert into MES_BookOfManage a (a,a.version,a.fDocumentNumber,a.fTaskType,a.fStatus,a.fCustomerID ,"
					+ "a.fCreatePersonID,a.fCreateDateTime,a.fLastUpdatePersonID,a.fLastUpdateDateTime) " + "values('" + thisID + "',0,'" + batchno + "','订单','拟制','" + customerID + "',"
					+ " :currentPersonID(),:currentDateTime(),:currentPersonID(),:currentDateTime())";
			KSQL.executeUpdate(ksql, null, DATA_MODEL, null);

			String[] bookID = list.split(",");
			for (int i = 0; i < bookID.length; i++) {
				// 判断是否已经存在任务数据
				ksql = "select a ,a.fStockCode from  MES_BookOfManageList a where  a.fSource = '" + bookID[i] + "'";
				Table tableList = KSQL.select(ksql, null, DATA_MODEL, null);
				if (tableList.size() > 0) {
					String fStockCode = tableList.iterator().next().getString("fStockCode");

					ERRORMESSAGE = fStockCode + "已经生成任务书，不能再次生成";
					int a = 1 / 0;

				}// 已经存在任务数据

				ksql = "select b.fStockCode,a.FAuxQty,a.FDate,b.fIsMps from SEOrderEntry a " + " optional join BAS_StockArchives b on  a.FItemID = b.fItemID where a = '" + bookID[i] + "'";
				Table tableD = KSQL.select(ksql, null, DATA_MODEL, null);

				String fStockCode = tableD.iterator().next().getString("fStockCode");// 编码
				String fIsMps = tableD.iterator().next().getString("fIsMps");// MPS件
				if (fStockCode == null) {
					ERRORMESSAGE = "存货编码不存在，请核实后生成";
					int a = 1 / 0;
				} else if ("是".equals(fIsMps)) {
					ERRORMESSAGE = fStockCode + "为MPS,不能在此生成生产任务书";
					int a = 1 / 0;
				}

				BigDecimal fNumber = tableD.iterator().next().getDecimal("FAuxQty");// 数量
				Date fDeliveryDate = tableD.iterator().next().getDateTime("FDate");// 日期

				// 判断是否工模
				String identCode = "";
				ksql = "select b.fStockCode from CAPP_MouldProductList a " + " optional join CAPP_Mould b on a.fMainID = b " + " where a.fStockCode = '" + fStockCode + "' and b.fStatus = '有效' ";
				Table table = KSQL.select(ksql, null, DATA_MODEL, null);
				if (table.size() > 0) {// 存在工模

					identCode = table.iterator().next().getString("fStockCode");// 工模标识
				}

				String detailID = UUID.randomUUID().randomUUID().toString().replace("-", "");// 子表ID

				ksql = "insert into MES_BookOfManageList a (a,a.version,a.fMainID,a.fCommonModeSign,a.fStockCode,a.fNumber,a.fDeliveryDate,a.fCreatePersonID,"
						+ "a.fCreateDateTime,a.fLastUpdatePersonID,a.fLastUpdateDateTime,a.fSign,a.fSource)  " + "values('" + detailID + "',0,'" + thisID + "','" + identCode + "','" + fStockCode
						+ "'," + fNumber + "," + "'" + fDeliveryDate + "',:currentPersonID(),:currentDateTime(),:currentPersonID(),:currentDateTime(),0,'" + bookID[i] + "') ";
				KSQL.executeUpdate(ksql, null, DATA_MODEL, null);

				// 资源锁定
				ResourceControlCenter.lockResources(fStockCode, bookID[i], "客户订单", detailID, "生产任务书", batchno, fNumber);

			}

			return "success";

		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(ERRORMESSAGE);
		}

	}

	/**
	 * 
	 * @Title: deleteBookByOrder
	 * @Description: TODO 根据客户订单撤回生产任务书 -拟制状态，并释放资源
	 * @param orderID
	 *            参数 客户订单子表
	 * @author duzx
	 * @return
	 * @date 2019-6-26
	 * @return void 返回类型
	 * 
	 */
	public static String deleteBookByOrder(String orderID) {
		try {

			String[] list = orderID.split(",");

			String filter = "and ( ";

			for (int i = 0; i < list.length; i++) {
				filter += " a.fSource = '" + list[i] + "' or ";
			}

			filter = filter.substring(0, filter.length() - 3);
			filter += ")";

			String fMainID = "";
			String ksql = "select a,a.fStockCode,a.fNumber,a.fSource,a.fMainID from MES_BookOfManageList a " + "  optional join MES_BookOfManage b on a.fMainID = b " + " where b.fStatus = '拟制'  "
					+ filter + "";
			Table table = KSQL.select(ksql, null, DATA_MODEL, null);
			if (table.size() > 0) {
				Iterator<Row> rows = table.iterator();
				while (rows.hasNext()) {
					Row row = rows.next();
					String fID = row.getString("a");
					String stockCode = row.getString("fStockCode");// 存货编码
					BigDecimal number = new BigDecimal(row.getInt("fNumber"));// 数量
					String fSource = row.getString("fSource");// 来源
					fMainID = row.getString("fMainID");

					// 解锁资源
					ResourceControlCenter.unlockResources(stockCode, fSource, "客户订单", fID, "生产任务书", number);

					String sql = "delete from MES_BookOfManageList a  where a  = '" + fID + "'";
					KSQL.executeUpdate(sql, null, DATA_MODEL, null);
				}

				ksql = "select a.* from MES_BookOfManageList a where a.fMainID = '" + fMainID + "'";
				table = KSQL.select(ksql, null, DATA_MODEL, null);
				if (table.size() <= 0) {// 该生产任务书下没有子表数据
					// 删除主表数据
					String sql = "delete from MES_BookOfManage  a where a = '" + fMainID + "'";
					KSQL.executeUpdate(sql, null, DATA_MODEL, null);
				}

			}
			return "success";

		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException();
		}
	}

	/**
	 * 
	 * @Title: deleteBookByOrder
	 * @Description: TODO 根据客户订单撤回生产任务书 -拟制状态，并释放资源
	 * @param bookID
	 *            参数 任务书ID
	 * @author duzx
	 * @return
	 * @return
	 * @date 2019-6-26
	 * @return void 返回类型
	 * 
	 */
	public static String deleteBookByID(String bookID) {
		try {
			String ksql = "select  a.* from MES_BookOfManage a where a = '" + bookID + "' and a.fStatus = '拟制'";
			Table table = KSQL.select(ksql, null, DATA_MODEL, null);
			if (table.size() > 0) {
				ksql = "select a,a.fStockCode,a.fNumber,a.fSource from MES_BookOfManageList a " + "  where a.fMainID = '" + bookID + "' ";

				table = KSQL.select(ksql, null, DATA_MODEL, null);
				if (table.size() > 0) {
					Iterator<Row> rows = table.iterator();
					while (rows.hasNext()) {
						Row row = rows.next();
						String fID = row.getString("a");
						String stockCode = row.getString("fStockCode");// 存货编码
						BigDecimal number = new BigDecimal(row.getInt("fNumber"));// 数量
						String fSource = row.getString("fSource");// 来源

						// 解锁资源
						ResourceControlCenter.unlockResources(stockCode, fSource, "客户订单", fID, "生产任务书", number);

						String sql = "delete from MES_BookOfManageList a  where a  = '" + fID + "'";
						KSQL.executeUpdate(sql, null, DATA_MODEL, null);
					}
				}

				// 删除主表数据
				String sql = "delete from MES_BookOfManage  a where a = '" + bookID + "'";
				KSQL.executeUpdate(sql, null, DATA_MODEL, null);

				return "success";
			} else {// 任务书不为拟制状态，不能删除
				return "status";
			}

		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException();
		}
	}

	/**
	 * 判断共模产品是否添加
	 * 
	 * @stockCode 传过来的存货编码
	 */
	public static JSONObject chekCommMode(String stockCode) {
		String code = stockCode;
		String[] attr = code.split(",");// 分成编码数组

		JSONObject json = new JSONObject();// 传回的总数据包含三部分数据
		JSONObject jscode = new JSONObject();// 添加无效编码
		JSONObject jmcode = new JSONObject();// 添加有效编码的模具编码

		// 找出有效的产品编码
		String sqlc = "select cm.fStockCode,c.fStockCode fmscode,b.fID,b.fDeliveryDate from capp_mouldproductlist cm inner join capp_mould c on cm.fMainID=c.fID inner join mes_bookofmanagelist b on cm.fStockCode=b.fStockCode where cm.fStockCode in("
				+ code + ") and c.fStatus='有效'";// 检查是否为
		// System.out.println(sqlc);
		Table table = SQL.select(Sql.DBMySql(sqlc), null, DATA_MODEL);
		Iterator<Row> rows = table.iterator();
		int a = 0;// 判断是否是无效编码
		Integer j = 0;// 作为无效编码key使用

		for (int i = 0; i < attr.length; i++) {// 循环遍历总产品编码
			if (table.size() != 0) {// 有效编码为空时
				while (rows.hasNext()) {// 循环遍历有效编码
					Row row = (Row) rows.next();
					String scode = "'" + row.getString("fStockCode") + "'";// 有效产品编码
					if (scode.equals(attr[i])) {// 有效编码+","+row.getString("fDeliveryDate")
						a = 1;
						jmcode.put(row.getString("fID"), row.getString("fmscode"));
						break;
					}
				}

				if (a != 1) {// 不等于1添加无效编码
					j = j + 1;
					jscode.put(j.toString(), attr[i]);
					a = 0;
				}
			} else {// 都为无效编码时
				j = j + 1;
				jscode.put(j.toString(), attr[i]);
			}
		}
		json.put("1", jscode);// 添加物无效编码
		json.put("3", jmcode);// 添加物有效编码的模具编码

		/**
		 * 寻找并添加其余共模产品
		 */
		String sql = " select distinct t1.fmscode,t1.fStockCode,t1.fRationNum from ( ";// 外层sql
		String sql1 = "";// 里层sql

		for (int i = 0; i < attr.length; i++) {// 循环添加里层sql
			if (attr.length != 1 && i != 0) {// 判断是否加 联合union all
				sql1 += " union all ";//用于联合查询所有存货编码所查出来的共模产品
			}
			sql1 += " select cl.fStockCode,cl.fRationNum,c.fStockCode fmscode from capp_mouldproductlist cl inner join capp_mould c on cl.fMainID=c.fID  where cl.fMainID in("
					+ " select c.fID from capp_mouldproductlist cm inner join capp_mould c on cm.fMainID=c.fID where cm.fStockCode in(" + attr[i] + ") and c.fStatus='有效') and cl.fStockCode not in("
					+ attr[i] + ")" + " and cl.fCombination in(select cm.fCombination from capp_mouldproductlist cm inner join capp_mould c on cm.fMainID=c.fID where cm.fStockCode in(" + attr[i]
					+ ") and c.fStatus='有效')";//查询单个存货编码相关的共模产品
		}

		sql = sql + sql1 + " ) t1 where t1.fStockCode not in(" + stockCode + ")";// 添加外层sql条件包装里层sql
		// System.out.println(sql);
		Table tables = SQL.select(Sql.DBMySql(sql), null, DATA_MODEL);// 其余共模产品
		json.put("2", tables);// 添加其余共模产品

		return json;
	}

}